<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Stringable;

/**
 * CameraType
 */
#[ORM\Table(name: 'camera_type', schema: 'collection')]
#[ORM\Entity]
class CameraType implements Stringable {
	use GetSet;

	#[ORM\Column(name: 'id', type: 'integer', nullable: FALSE)]
	#[ORM\Id]
	#[ORM\GeneratedValue(strategy: 'IDENTITY')]
	#[ORM\SequenceGenerator(sequenceName: 'camera.camera_type_id_seq', allocationSize: 1, initialValue: 1)]
	private int $id;

	#[ORM\Column(name: 'type', type: 'string', length: 255, nullable: FALSE)]
	private string $type;

	#[ORM\Column(name: 'description', type: 'text', nullable: TRUE)]
	private ?string $description = NULL;

	// ------------------------------------------------------------------------

	/**
	 * Value for serialization
	 */
	public function __toString(): string
	{
		return $this->type;
	}
}
