<?php declare(strict_types=1);

namespace App\Form;

use App\Entity\Socket;
use App\Enum\SocketType;
use Symfony\Component\Form\Extension\Core\Type\EnumType;
use Symfony\Component\Form\{AbstractType, FormBuilderInterface};
use Symfony\Component\OptionsResolver\OptionsResolver;

class SocketTypeForm extends AbstractType {
	public function buildForm(FormBuilderInterface $builder, array $options): void
	{
		$builder
			->add('name')
			->add('otherName')
			->add('pinCount')
			->add('type', EnumType::class, [
				'class' => SocketType::class,
			]);
	}

	public function configureOptions(OptionsResolver $resolver): void
	{
		$resolver->setDefaults([
			'data_class' => Socket::class,
		]);
	}
}
